package backend.hdl.arch.rewrite

import backend.hdl.arch.{ArchLambda, InverseRepeatHidden, MapOrderedStream, MapVector, Select}
import core.{Expr, LambdaT, ParamUse}
import core.rewrite.Rule

/**
  * TODO This is a temporary fix only
  */
object FixInverseRepeatHiddenRules {
  def all: Seq[Rule] = Seq(removeInverseRepeatFromMapStmMapVecSelect)

  def removeInverseRepeatFromMapStmMapVecSelect: Rule = Rule("removeInverseRepeatFromMapStmMapVecSelect", {
    case MapOrderedStream(outerFun: LambdaT, input, _) if {
      var outerExprFound = false
      outerFun.body.visit{
        case MapVector(fun: LambdaT, innerInput, _) if {
          var exprFound = false
          innerInput.visit{
            case Select(ParamUse(p), _, _) if outerFun.param.id == p.id =>
              exprFound = true
            case _ =>
          }
          exprFound
        } && {
          var exprFound = false
          fun.body.visit{
            case InverseRepeatHidden(ParamUse(p), _, _) if outerFun.param.id == p.id =>
              exprFound = true
            case _ =>
          }
          exprFound
        } =>
          outerExprFound = true
        case _ =>
      }
      outerExprFound
    } =>
      MapOrderedStream(
        ArchLambda(
          outerFun.param,
          outerFun.body.visitAndRebuild{
            case MapVector(fun: LambdaT, innerInput, _) if {
              var exprFound = false
              innerInput.visit{
                case Select(ParamUse(p), _, _) if outerFun.param.id == p.id =>
                  exprFound = true
                case _ =>
              }
              exprFound
            } && {
              var exprFound = false
              fun.body.visit{
                case InverseRepeatHidden(ParamUse(p), _, _) if outerFun.param.id == p.id =>
                  exprFound = true
                case _ =>
              }
              exprFound
            } =>
              MapVector(
                ArchLambda(
                  fun.param,
                  fun.body.visitAndRebuild{
                    case InverseRepeatHidden(ParamUse(p), _, _) if outerFun.param.id == p.id =>
                      ParamUse(p)
                    case e => e
                  }.asInstanceOf[Expr]
                ),
                innerInput)
            case e => e
          }.asInstanceOf[Expr]
        )
        ,input
      )
  })
}
